Index: /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 253)
@@ -3,26 +3,25 @@
 ! symbols '&' in columns 73 and 6
 !
-      COMMON/callkeys/callrad,corrk,calldifv,calladj,                   &
-     &   co2cond,callsoil,                                              &
-     &   season,diurnal,tlocked,iradia,lwrite,calllott                  &
-     &   ,iaervar,iddist,topdustref,callstats,calleofdump               &
-     &   ,enertest                                                      &
-     &   ,callgasvis,callnlte,callthermos,callconduct,                  &
-     &        calleuv,callmolvis,callmoldiff,thermochem                 &
-     &   , solarcondate, Nmix_co2, Nmix_h2o, thermoswater               &
-     &   , semi                                                         &
-     &   , callemis                                                     &
-     &   , callg2d                                                      &
-     &   , linear                                                       &
-     &   , ilwd                                                         &
-     &   , ilwb                                                         &
-     &   , ilwn                                                         &
-     &   , ncouche                                                      &
-     &   , alphan                                                       &
+      COMMON/callkeys/callrad,corrk,calldifv,calladj                    &
+     &   , co2cond,callsoil                                             &
+     &   , season,diurnal,tlocked,iradia,lwrite                         &
+     &   , iaervar,iddist,topdustref,callstats,calleofdump              &
+     &   , enertest                                                     &
+     &   , callgasvis                                                   &
+     &   , Nmix_co2, Nmix_h2o                                           &
+     &   , dusttau                                                      &
      &   , nonideal                                                     &
      &   , meanOLR                                                      &
      &   , specOLR                                                      &
+     &   , kastprof                                                     &
+     &   , noradsurf                                                    &
+     &   , Tsurfk                                                       &
+     &   , Tstrat                                                       &
+     &   , newtonian                                                    &
+     &   , tau_relax                                                    &
+     &   , testradtimes                                                 &
      &   , rayleigh                                                     &
-     &   , ozone                                                        &
+     &   , stelbbody                                                    &
+     &   , stelTbb                                                      &
      &   , tplanet                                                      &
      &   , startype                                                     &
@@ -36,20 +35,30 @@
      &   , rainthreshold                                                &
      &   , aerofixed                                                    &
-     &   , photochem,nqchem_min                                         
+     &   , szangle                                                      &
+     &   , hydrology                                                    &
+     &   , sourceevol                                                   &
+     &   , albedosnow                                                   &
+     &   , maxicethick                                                  &
+     &   , Tsaldiff                                                     &
+     &   , CLFfixval                                                    &
+     &   , CLFvarying                                                   &
+     &   , n2mixratio                                                   &
+     &   , co2supsat                                                    &
+     &   , pceil                                                    
 
-      logical callrad,corrk,calldifv,calladj,co2cond,callsoil,          &
-     &   season,diurnal,tlocked,lwrite,calllott                         &
-     &   ,callstats,calleofdump                                         &
-     &   ,callgasvis,callnlte,callthermos,callconduct,                  &
-     &    calleuv,callmolvis,callmoldiff,thermochem,thermoswater
+      logical callrad,corrk,calldifv,calladj,co2cond,callsoil           &
+     &   , season,diurnal,tlocked,lwrite                                &
+     &   , callstats,calleofdump                                        &
+     &   , callgasvis
 
       logical enertest
-      logical callemis
-      logical callg2d
-      logical linear
       logical nonideal
       logical meanOLR
       logical specOLR
+      logical kastprof
+      logical newtonian
+      logical testradtimes
       logical rayleigh
+      logical stelbbody
       logical ozone
       logical nearco2cond
@@ -60,25 +69,32 @@
       logical water,watercond,waterrain
       logical aerofixed
-      logical photochem
+      logical hydrology
+      logical sourceevol
+      logical CLFvarying
+      logical noradsurf
 
       integer iddist
       integer iaervar
       integer iradia
-      integer ilwd
-      integer ilwb
-      integer ilwn
-      integer ncouche
-      integer dustbin
       integer startype
-      integer nqchem_min
 
       real topdustref
-      real semi
-      real alphan
-      real solarcondate
       real Nmix_co2
       real Nmix_h2o
+      real dusttau
       real Fat1AU
+      real stelTbb
+      real Tstrat
       real tplanet
       real satval
       real rainthreshold
+      real szangle
+      real CLFfixval
+      real n2mixratio
+      real co2supsat
+      real pceil
+      real albedosnow
+      real maxicethick
+      real Tsaldiff
+      real Tsurfk
+      real tau_relax
Index: /trunk/LMDZ.GENERIC/libf/phystd/callsedim.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 253)
@@ -1,5 +1,5 @@
       SUBROUTINE callsedim(ngrid,nlay, ptimestep,
      $                pplev,zlev, pt,
-     &                pq, pdqfi, pdqsed,pdqs_sed,nq)
+     &                pq, pdqfi, pdqsed,pdqs_sed,nq,rfall)
       IMPLICIT NONE
 
@@ -29,5 +29,5 @@
 
 #include "fisice.h"
-c
+
 c   arguments:
 c   ----------
@@ -84,5 +84,4 @@
 !     (mass (kg.m-2), thickness (m), etc.
 
-
       do  l=1,nlay
         do ig=1, ngrid
@@ -92,6 +91,5 @@
       end do
 
-      do iq=1,nq
-        if(radius(iq).gt.1.e-9) then   ! no sedimentation for gases (defined by radius=0)
+      iq=igcm_h2o_ice
 
 !     The value of q is updated after the other parameterisations
@@ -101,27 +99,14 @@
               ! store locally updated tracers
               zqi(ig,l)=pq(ig,l,iq)+pdqfi(ig,l,iq)*ptimestep
-!              if (iceparty.and.(iq.eq.igcm_h2o_ice)) then
-              if (iq.eq.igcm_h2o_ice) then
-c               On affecte un rayon moyen aux poussieres a chaque altitude du type :
-c               r(z)=r0*exp(-z/H) avec r0=0.8 micron et H=18 km.
-c               ''''''''''''''''''''''''''''''''''''''''''''''''
-                rfall(ig,l)=max( rice(ig,l)*1.5,rdust(ig,l) )
-c modif FranckMM pour ameliorer cycle H2O: rfall= 20 microns
-                rfall(ig,l)=min(rfall(ig,l),1.e-4)
-              endif
             enddo
           enddo ! of do l=1,nlay
+
+
 
 !=======================================================================
 !     Calculate the transport due to sedimentation for each tracer
 
-          if (iq.eq.igcm_h2o_ice) then
-          !if (iceparty.and.(iq.eq.igcm_h2o_ice)) then
-            call newsedim(ngrid,nlay,ngrid*nlay,ptimestep,
-     &      pplev,masse,epaisseur,pt,rfall,rho_q(iq),zqi,wq)
-          else
-            call newsedim(ngrid,nlay,1,ptimestep,
-     &      pplev,masse,epaisseur,pt,radius(iq),rho_q(iq),zqi,wq)
-          endif
+          call newsedim(ngrid,nlay,ngrid*nlay,ptimestep,
+     &         pplev,masse,epaisseur,pt,rfall,rho_q(iq),zqi,wq)
 
 !=======================================================================
@@ -140,8 +125,5 @@
           ENDDO
 
-        endif ! of if(radius(iq).gt.1.e-9)
-      enddo ! of do iq=1,nq
- 
-      RETURN
-      END
+      return
+      end
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/comcstfi.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comcstfi.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comcstfi.h	(revision 253)
@@ -3,7 +3,7 @@
 
       common/comcstfi/pi,rad,g,r,cpp,rcp,dtphys,daysec,mugaz,omeg
-      common/comcstfi/avocado,molrad,visc
+      common/comcstfi/avocado!,molrad,visc
 
       real pi,rad,g,r,cpp,rcp,dtphys,daysec,mugaz,omeg
-      real avocado,molrad,visc
+      real avocado!,molrad,visc
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/comdiurn.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comdiurn.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comdiurn.h	(revision 253)
@@ -1,5 +1,6 @@
-      COMMON/comdiurn/ldiurn,
-     s     sinlon(ngridmx),coslon(ngridmx),
-     s     sinlat(ngridmx),coslat(ngridmx)
-      REAL sinlon,coslon,sinlat,coslat
-      LOGICAL ldiurn
+      COMMON/comdiurn/ldiurn,                                           &
+     &     sinlon(ngridmx),coslon(ngridmx),                             &
+     &     sinlat(ngridmx),coslat(ngridmx)
+      
+      real sinlon,coslon,sinlat,coslat
+      logical ldiurn
Index: /trunk/LMDZ.GENERIC/libf/phystd/comg1d.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comg1d.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comg1d.h	(revision 253)
@@ -1,27 +1,27 @@
-c.......................................................................
-c  le COMMON pour GRADS-1D
-c  (Utilise pour les sorties format Grads dans la version 1D du modele)
-c
-c  on peut se dire : "on ne sauvera pas plus de 1000 variables ... hein ?"
-c
+!.......................................................................
+!  le COMMON pour GRADS-1D
+!  (Utilise pour les sorties format Grads dans la version 1D du modele)
+!
+!  on peut se dire : "on ne sauvera pas plus de 1000 variables ... hein ?"
+!
       INTEGER g1d_nvarmx
       PARAMETER(g1d_nvarmx=1000)
-c
-c         * g1d_nlayer     ---> nombre de couches verticales
-c         * g1d_nomfich    ---> nom du fichier grads
-c         * g1d_unitfich   ---> code du fichier grads
-c         * g1d_nomctl     ---> nom du fichier ctl
-c         * g1d_unitctl    ---> code du fichier ctl
-c         * g1d_premier    ---> variable logique pour dire si le fichier
-c                               est deja ouvert
-c         * g1d_irec       ---> indice de derniere ecriture
-c         * g1d_nvar       ---> nombre de variables deja definies a la
-c                               derniere ecriture
-c         * g1d_nomvar     ---> noms des vecteurs existants
-c         * g1d_dimvar     ---> taille des vecteurs
-c         * g1d_titrevar   ---> titres des vecteurs
-c         * g1d_tmp1       ---> caractere 
-c         * g1d_tmp2       ---> caractere 
-c
+
+!         * g1d_nlayer     ---> nombre de couches verticales
+!         * g1d_nomfich    ---> nom du fichier grads
+!         * g1d_unitfich   ---> code du fichier grads
+!         * g1d_nomctl     ---> nom du fichier ctl
+!         * g1d_unitctl    ---> code du fichier ctl
+!         * g1d_premier    ---> variable logique pour dire si le fichier
+!                               est deja ouvert
+!         * g1d_irec       ---> indice de derniere ecriture
+!         * g1d_nvar       ---> nombre de variables deja definies a la
+!                               derniere ecriture
+!         * g1d_nomvar     ---> noms des vecteurs existants
+!         * g1d_dimvar     ---> taille des vecteurs
+!         * g1d_titrevar   ---> titres des vecteurs
+!         * g1d_tmp1       ---> caractere 
+!         * g1d_tmp2       ---> caractere 
+
       INTEGER g1d_nlayer
       CHARACTER*100 g1d_nomfich
@@ -43,21 +43,21 @@
       integer saveG1D
 
-      COMMON/COMG1DI/g1d_nlayer
-     &             ,g1d_unitfich
-     &             ,g1d_unitctl
-     &             ,g1d_irec
-     &             ,g2d_irec
-     &             ,g2d_appel
-     &             ,g1d_nvar
+      COMMON/COMG1DI/g1d_nlayer                                         &
+     &             ,g1d_unitfich                                        &
+     &             ,g1d_unitctl                                         &
+     &             ,g1d_irec                                            &
+     &             ,g2d_irec                                            &
+     &             ,g2d_appel                                           &
+     &             ,g1d_nvar                                            &
      &             ,saveG1D
-      COMMON/COMG1DC/g1d_dimvar(0:g1d_nvarmx)
-     &             ,g1d_nomfich
-     &             ,g1d_nomctl
-     &             ,g1d_nomvar(0:g1d_nvarmx)
-     &             ,g1d_titrevar(0:g1d_nvarmx)
-     &             ,g1d_tmp1
-     &             ,g1d_tmp2
-      COMMON/COMG1DL/g1d_premier
+      COMMON/COMG1DC/g1d_dimvar(0:g1d_nvarmx)                           &
+     &             ,g1d_nomfich                                         &
+     &             ,g1d_nomctl                                          &
+     &             ,g1d_nomvar(0:g1d_nvarmx)                            &
+     &             ,g1d_titrevar(0:g1d_nvarmx)                          &
+     &             ,g1d_tmp1                                            &
+     &             ,g1d_tmp2                                            
+      COMMON/COMG1DL/g1d_premier                                        &
      &             ,g2d_premier
-c
-c.......................................................................
+!
+!.......................................................................
Index: /trunk/LMDZ.GENERIC/libf/phystd/comsaison.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comsaison.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comsaison.h	(revision 253)
@@ -1,11 +1,11 @@
-c-----------------------------------------------------------------------
-c   INCLUDE saison.h
+!-----------------------------------------------------------------------
+!   INCLUDE saison.h
 
-      COMMON/saison/callsais,isaison,dist_sol,declin,
-     $             mu0(ngridmx),fract(ngridmx)
+      COMMON/saison/callsais,isaison,dist_star,declin,                   &
+     &             mu0(ngridmx),fract(ngridmx)
 
-      INTEGER isaison
-      LOGICAL callsais
-      REAL dist_sol,declin,mu0,fract
+      integer isaison
+      logical callsais
+      real dist_star,declin,mu0,fract
 
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/condens_co2cloud.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/condens_co2cloud.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/condens_co2cloud.F90	(revision 253)
@@ -17,5 +17,5 @@
 !  
 !     Inputs
-!     ------ 
+!     ------
 !     ngrid                 Number of vertical columns
 !     nlayer                Number of layers
@@ -56,4 +56,5 @@
 #include "callkeys.h"
 #include "tracer.h"
+#include "gases.h"
 
 !-----------------------------------------------------------------------
@@ -142,5 +143,11 @@
       CHARACTER(LEN=20) :: tracername ! to temporarily store text
 
+      integer igas
+      integer,save :: igasco2=0
+      character(len=3) :: gasname
+
       real reffradmin, reffradmax
+
+      real ppco2
 
 !-----------------------------------------------------------------------
@@ -154,19 +161,30 @@
       !reffradmin=1.e-7
       !reffradmax=5.e-4
-      reffradmin=0.5e-7
-      reffradmax=0.1e-3 ! FF data
-      !reffradmin=0.1e-5
-      !reffradmax=0.5e-3 ! JB data
+      !reffradmin=0.5e-7
+      !reffradmax=0.1e-3 ! FF data
+      reffradmin=0.1e-5
+      reffradmax=0.1e-3 ! JB data
 !     improve this in the future...
 
 !     Initialisation
       IF (firstcall) THEN
-        do iq=1,nqmx
-          tracername=noms(iq)
-          if (tracername.eq."co2_ice") then
-            i_co2ice=iq
-          endif
-        enddo
-        
+
+         ! find CO2 ice tracer
+         do iq=1,nqmx
+            tracername=noms(iq)
+            if (tracername.eq."co2_ice") then
+               i_co2ice=iq
+            endif
+         enddo
+         
+         ! find CO2 gas
+         do igas=1,ngasmx
+            gasname=gnom(igas)
+!            gasname=noms(igas) ! was a bug
+            if (gasname.eq."CO2") then
+               igasco2=igas
+            endif
+         enddo
+
         write(*,*) "condense_co2cloud: i_co2ice=",i_co2ice       
 
@@ -179,5 +197,20 @@
          print*,'In condens_co2cloud: ccond=',ccond,' latcond=',latcond
 
-         firstcall=.false.
+!          Prepare special treatment if gas is not pure CO2
+             !if (addn2) then
+             !   m_co2   = 44.01E-3 ! CO2 molecular mass (kg/mol)   
+             !   m_noco2 = 28.02E-3 ! N2 molecular mass (kg/mol)  
+!               Compute A and B coefficient use to compute
+!               mean molecular mass Mair defined by
+!               1/Mair = q(ico2)/m_co2 + (1-q(ico2))/m_noco2
+!               1/Mair = A*q(ico2) + B
+             !   A = (1/m_co2 - 1/m_noco2)
+             !   B = 1/m_noco2
+             !endif
+
+!          Minimum CO2 mixing ratio below which mixing occurs with layer above: 
+           !qco2min =0.75  
+
+           firstcall=.false.
       ENDIF
       zcpi=1./cpp
@@ -217,8 +250,29 @@
 !     Atmospheric condensation
 
+
+!     Compute CO2 Volume mixing ratio
+!     -------------------------------
+!      if (addn2) then
+!         DO l=1,nlayer
+!            DO ig=1,ngrid
+!              qco2=pq(ig,l,ico2)+pdq(ig,l,ico2)*ptimestep
+!!             Mean air molecular mass = 1/(q(ico2)/m_co2 + (1-q(ico2))/m_noco2)
+!              mmean=1/(A*qco2 +B)
+!              vmr_co2(ig,l) = qco2*mmean/m_co2 
+!            ENDDO
+!         ENDDO
+!      else
+!         DO l=1,nlayer
+!            DO ig=1,ngrid
+!              vmr_co2(ig,l)=0.5
+!            ENDDO
+!         ENDDO
+!      end if
+
 !     Forecast the atmospheric frost temperature 'ztcond'
       DO l=1,nlayer
          DO ig=1,ngrid
-            call get_tcond_co2(pplay(ig,l),ztcond(ig,l),1,1)
+            ppco2=gfrac(igasco2)*pplay(ig,l)
+            call get_tcond_co2(ppco2,ztcond(ig,l))
          ENDDO
       ENDDO
@@ -234,6 +288,4 @@
                   print*,'Perhaps the atmosphere is collapsing on surface...?'
                endif
-               stop
-
             END IF
          ENDDO
@@ -275,5 +327,4 @@
                ! there should be a more elegant way of doing this...
                if(reff.lt.1.e-16) reff=1.e-16
-
 
                ! update reffrad for radiative transfer
@@ -290,6 +341,7 @@
                call stokes                      &
                    (pplev(ig,ilay),pt(ig,ilay), &
-                    reff,vstokes,rho_co2) 
-
+                    reff,vstokes,rho_co2)
+
+               !w(ig,ilay,i_co2ice) = 0.0
                w(ig,ilay,i_co2ice) = vstokes *  subptimestep * &
                    pplev(ig,ilay)/(r*pt(ig,ilay))
@@ -369,7 +421,7 @@
 !     forecast of ground temperature ztsrf and frost temperature ztcondsol
       DO ig=1,ngrid
-
-         call get_tcond_co2(pplev(ig,1),ztcondsol(ig))
-
+         ppco2=gfrac(igasco2)*pplay(ig,1)
+         call get_tcond_co2(ppco2,ztcondsol(ig))
+         
          ztsrf(ig) = ptsrf(ig)
 
@@ -466,6 +518,17 @@
       implicit none
 
-      real p, tcond
-      tcond = (-3167.8)/(log(.01*p)-23.23) ! Fanale's formula
+#include "callkeys.h"
+
+      real p, peff, tcond
+      real, parameter :: ptriple=518000.0
+
+      peff=p!/co2supsat
+
+      if(peff.lt.ptriple)then
+         tcond = (-3167.8)/(log(.01*peff)-23.23) ! Fanale's formula
+      else
+         tcond = 684.2-92.3*log(peff)+4.32*log(peff)**2 
+         ! liquid-vapour transition (based on CRC handbook 2003 data)
+      endif
       return
 
